﻿using Exam.Share.Dtos.Trains;
using Exam.Share.ViewResponses.Train;
using Exam.Trains;
using Hotline.Repository.SqlSugar.Interface;
using Hotline.Share.Dtos.Trains;
using Hotline.Share.Requests.Exam;
using Hotline.Share.Requests.Train;

namespace Train.Application.Interface.Train
{
    public interface ITrainRecordService:IQueryService<TrainRecordViewResponse,TrainRecordDto,TrainRecordPagedRequest>,IApiService<AddTrainRecordDto,UpdateTrainRecordDto,TrainRecord>
    {
        /// <summary>
        /// 结束培训
        /// </summary>
        /// <param name="completeTrainRecordDto"></param>
        /// <returns></returns>
        Task CompleteTrainRecordAsync(CompleteTrainRecordDto completeTrainRecordDto,CancellationToken cancellationToken);

        /// <summary>
        /// 获取培训试题
        /// </summary>
        /// <param name="examQuestionRequest"></param>
        /// <returns></returns>
        Task<TrainQuestionDto> GetTrainQuestionDto(TrainQuestionRequest trainQuestionRequest);

        /// <summary>
        /// 初次培训
        /// </summary>
        /// <param name="addUserTrainItemDto"></param>
        /// <returns></returns>
        Task<List<TrainPracticeOptionsDto>> TrainAsync(AddTrainDto addTrainDto, CancellationToken cancellationToken);

        /// <summary>
        /// 获取培训习题
        /// </summary>
        /// <param name="trainPracticeRequest"></param>
        /// <returns></returns>
        Task<TrainPracticeDto> GetTrainPracticeAsync(TrainPracticeRequest trainPracticeRequest);

        /// <summary>
        /// 完成培训课件学习
        /// </summary>
        /// <param name="completeTrainPracticeDto"></param>
        /// <returns></returns>
        Task CompleteTrainKnowladgeAsync(CompleteTrainKnowladgeDto completeTrainPracticeDto, CancellationToken cancellationToken);
    }
}
